/* Problem URL: https://codeforces.com/problemset/problem/1270/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;

struct pt {
    ll x, y;

    pt() = default;
    pt(ll x, ll y): x(x), y(y) {}

    friend istream &operator >> (istream &is, pt &a) {
        is >> a.x >> a.y;
        return is;
    }
};

void pre()
{

}

#define TEST 0

void solve()
{
    int n;
    cin >> n;

    V<pt> a(n);
    cin >> a;

    auto check = [&]() {
        set<pair<int, int>> c;
        repv(i, a) {
            c.emplace(i.x & 1, i.y & 1);
        }

        if (c.size() == 1) {
            return true;
        }

        return false;
    };

    while (check()) {
        nrep(i, 1, n) {
            a[i] = pt((a[i].x - a[0].x) / 2 + a[0].x, (a[i].y - a[0].y) / 2 + a[0].y);
        }
    }

    map<pair<int, int>, vi> c;
    rep(i, n) {
        c[{a[i].x & 1, a[i].y & 1}].push_back(i + 1);
    }

    if ((c.count({0, 0}) || c.count({1, 1})) && (c.count({1, 0}) || c.count({0, 1}))) {
        auto v1 = c[{0, 0}];
        auto v2 = c[{1, 1}];
        
        cout << v1.size() + v2.size() << '\n';
        repv(i, v1) {
            cout << i << ' ';
        }
        repv(i, v2) {
            cout << i << ' ';
        }
        cout << '\n';
        return;
    }

    auto v1 = c[{0, 0}];
    auto v2 = c[{0, 1}];
    cout << v1.size() + v2.size() << '\n';
    repv(i, v1) {
        cout << i << ' ';
    }
    repv(i, v2) {
        cout << i << ' ';
    }
    cout << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
